t / test-lib.shon commit tests: test the test framework more thoroughly (5ebf89e)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# Test the binaries we have just built.  The tests are kept in
  38# t/ subdirectory and are run in 'trash directory' subdirectory.
  39if test -z "$TEST_DIRECTORY"
  40then
  41        # We allow tests to override this, in case they want to run tests
  42        # outside of t/, e.g. for running tests on the test library
  43        # itself.
  44        TEST_DIRECTORY=$(pwd)
  45fi
  46if test -z "$TEST_OUTPUT_DIRECTORY"
  47then
  48        # Similarly, override this to store the test-results subdir
  49        # elsewhere
  50        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  51fi
  52GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  53
  54. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  55export PERL_PATH SHELL_PATH
  56
  57# For repeatability, reset the environment to known value.
  58LANG=C
  59LC_ALL=C
  60PAGER=cat
  61TZ=UTC
  62TERM=dumb
  63export LANG LC_ALL PAGER TERM TZ
  64EDITOR=:
  65# A call to "unset" with no arguments causes at least Solaris 10
  66# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  67# deriving from the command substitution clustered with the other
  68# ones.
  69unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  70        my @env = keys %ENV;
  71        my $ok = join("|", qw(
  72                TRACE
  73                DEBUG
  74                USE_LOOKUP
  75                TEST
  76                .*_TEST
  77                PROVE
  78                VALGRIND
  79                PERF_AGGREGATING_LATER
  80        ));
  81        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  82        print join("\n", @vars);
  83')
  84unset XDG_CONFIG_HOME
  85GIT_AUTHOR_EMAIL=author@example.com
  86GIT_AUTHOR_NAME='A U Thor'
  87GIT_COMMITTER_EMAIL=committer@example.com
  88GIT_COMMITTER_NAME='C O Mitter'
  89GIT_MERGE_VERBOSITY=5
  90GIT_MERGE_AUTOEDIT=no
  91export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
  92export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  93export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  94export EDITOR
  95
  96# Protect ourselves from common misconfiguration to export
  97# CDPATH into the environment
  98unset CDPATH
  99
 100unset GREP_OPTIONS
 101
 102case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1031|2|true)
 104        echo "* warning: Some tests will not work if GIT_TRACE" \
 105                "is set as to trace on STDERR ! *"
 106        echo "* warning: Please set GIT_TRACE to something" \
 107                "other than 1, 2 or true ! *"
 108        ;;
 109esac
 110
 111# Convenience
 112#
 113# A regexp to match 5 and 40 hexdigits
 114_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 115_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 116
 117# Zero SHA-1
 118_z40=0000000000000000000000000000000000000000
 119
 120# Line feed
 121LF='
 122'
 123
 124export _x05 _x40 _z40 LF
 125
 126# Each test should start with something like this, after copyright notices:
 127#
 128# test_description='Description of this test...
 129# This test checks if command xyzzy does the right thing...
 130# '
 131# . ./test-lib.sh
 132[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 133                TERM=$ORIGINAL_TERM &&
 134                export TERM &&
 135                [ -t 1 ] &&
 136                tput bold >/dev/null 2>&1 &&
 137                tput setaf 1 >/dev/null 2>&1 &&
 138                tput sgr0 >/dev/null 2>&1
 139        ) &&
 140        color=t
 141
 142while test "$#" -ne 0
 143do
 144        case "$1" in
 145        -d|--d|--de|--deb|--debu|--debug)
 146                debug=t; shift ;;
 147        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 148                immediate=t; shift ;;
 149        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 150                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 151        -h|--h|--he|--hel|--help)
 152                help=t; shift ;;
 153        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 154                verbose=t; shift ;;
 155        -q|--q|--qu|--qui|--quie|--quiet)
 156                # Ignore --quiet under a TAP::Harness. Saying how many tests
 157                # passed without the ok/not ok details is always an error.
 158                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 159        --with-dashes)
 160                with_dashes=t; shift ;;
 161        --no-color)
 162                color=; shift ;;
 163        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 164                valgrind=t; verbose=t; shift ;;
 165        --tee)
 166                shift ;; # was handled already
 167        --root=*)
 168                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 169                shift ;;
 170        *)
 171                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 172        esac
 173done
 174
 175if test -n "$color"
 176then
 177        say_color () {
 178                (
 179                TERM=$ORIGINAL_TERM
 180                export TERM
 181                case "$1" in
 182                error)
 183                        tput bold; tput setaf 1;; # bold red
 184                skip)
 185                        tput setaf 4;; # blue
 186                warn)
 187                        tput setaf 3;; # brown/yellow
 188                pass)
 189                        tput setaf 2;; # green
 190                info)
 191                        tput setaf 6;; # cyan
 192                *)
 193                        test -n "$quiet" && return;;
 194                esac
 195                shift
 196                printf "%s" "$*"
 197                tput sgr0
 198                echo
 199                )
 200        }
 201else
 202        say_color() {
 203                test -z "$1" && test -n "$quiet" && return
 204                shift
 205                echo "$*"
 206        }
 207fi
 208
 209error () {
 210        say_color error "error: $*"
 211        GIT_EXIT_OK=t
 212        exit 1
 213}
 214
 215say () {
 216        say_color info "$*"
 217}
 218
 219test "${test_description}" != "" ||
 220error "Test script did not set test_description."
 221
 222if test "$help" = "t"
 223then
 224        echo "$test_description"
 225        exit 0
 226fi
 227
 228exec 5>&1
 229exec 6<&0
 230if test "$verbose" = "t"
 231then
 232        exec 4>&2 3>&1
 233else
 234        exec 4>/dev/null 3>/dev/null
 235fi
 236
 237test_failure=0
 238test_count=0
 239test_fixed=0
 240test_broken=0
 241test_success=0
 242
 243test_external_has_tap=0
 244
 245die () {
 246        code=$?
 247        if test -n "$GIT_EXIT_OK"
 248        then
 249                exit $code
 250        else
 251                echo >&5 "FATAL: Unexpected exit with code $code"
 252                exit 1
 253        fi
 254}
 255
 256GIT_EXIT_OK=
 257trap 'die' EXIT
 258
 259# The user-facing functions are loaded from a separate file so that
 260# test_perf subshells can have them too
 261. "$TEST_DIRECTORY/test-lib-functions.sh"
 262
 263# You are not expected to call test_ok_ and test_failure_ directly, use
 264# the text_expect_* functions instead.
 265
 266test_ok_ () {
 267        test_success=$(($test_success + 1))
 268        say_color "" "ok $test_count - $@"
 269}
 270
 271test_failure_ () {
 272        test_failure=$(($test_failure + 1))
 273        say_color error "not ok $test_count - $1"
 274        shift
 275        echo "$@" | sed -e 's/^/#       /'
 276        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 277}
 278
 279test_known_broken_ok_ () {
 280        test_fixed=$(($test_fixed+1))
 281        say_color "" "ok $test_count - $@ # TODO known breakage"
 282}
 283
 284test_known_broken_failure_ () {
 285        test_broken=$(($test_broken+1))
 286        say_color warn "not ok $test_count - $@ # TODO known breakage"
 287}
 288
 289test_debug () {
 290        test "$debug" = "" || eval "$1"
 291}
 292
 293test_eval_ () {
 294        # This is a separate function because some tests use
 295        # "return" to end a test_expect_success block early.
 296        eval </dev/null >&3 2>&4 "$*"
 297}
 298
 299test_run_ () {
 300        test_cleanup=:
 301        expecting_failure=$2
 302        test_eval_ "$1"
 303        eval_ret=$?
 304
 305        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 306        then
 307                test_eval_ "$test_cleanup"
 308        fi
 309        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 310        then
 311                echo ""
 312        fi
 313        return "$eval_ret"
 314}
 315
 316test_skip () {
 317        test_count=$(($test_count+1))
 318        to_skip=
 319        for skp in $GIT_SKIP_TESTS
 320        do
 321                case $this_test.$test_count in
 322                $skp)
 323                        to_skip=t
 324                        break
 325                esac
 326        done
 327        if test -z "$to_skip" && test -n "$test_prereq" &&
 328           ! test_have_prereq "$test_prereq"
 329        then
 330                to_skip=t
 331        fi
 332        case "$to_skip" in
 333        t)
 334                of_prereq=
 335                if test "$missing_prereq" != "$test_prereq"
 336                then
 337                        of_prereq=" of $test_prereq"
 338                fi
 339
 340                say_color skip >&3 "skipping test: $@"
 341                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 342                : true
 343                ;;
 344        *)
 345                false
 346                ;;
 347        esac
 348}
 349
 350# stub; perf-lib overrides it
 351test_at_end_hook_ () {
 352        :
 353}
 354
 355test_done () {
 356        GIT_EXIT_OK=t
 357
 358        if test -z "$HARNESS_ACTIVE"
 359        then
 360                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 361                mkdir -p "$test_results_dir"
 362                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 363
 364                cat >>"$test_results_path" <<-EOF
 365                total $test_count
 366                success $test_success
 367                fixed $test_fixed
 368                broken $test_broken
 369                failed $test_failure
 370
 371                EOF
 372        fi
 373
 374        if test "$test_fixed" != 0
 375        then
 376                say_color pass "# fixed $test_fixed known breakage(s)"
 377        fi
 378        if test "$test_broken" != 0
 379        then
 380                say_color warn "# still have $test_broken known breakage(s)"
 381                msg="remaining $(($test_count-$test_broken)) test(s)"
 382        else
 383                msg="$test_count test(s)"
 384        fi
 385        case "$test_failure" in
 386        0)
 387                # Maybe print SKIP message
 388                if test -n "$skip_all" && test $test_count -gt 0
 389                then
 390                        error "Can't use skip_all after running some tests"
 391                fi
 392                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 393
 394                if test $test_external_has_tap -eq 0
 395                then
 396                        if test $test_count -gt 0
 397                        then
 398                                say_color pass "# passed all $msg"
 399                        fi
 400                        say "1..$test_count$skip_all"
 401                fi
 402
 403                test -d "$remove_trash" &&
 404                cd "$(dirname "$remove_trash")" &&
 405                rm -rf "$(basename "$remove_trash")"
 406
 407                test_at_end_hook_
 408
 409                exit 0 ;;
 410
 411        *)
 412                if test $test_external_has_tap -eq 0
 413                then
 414                        say_color error "# failed $test_failure among $msg"
 415                        say "1..$test_count"
 416                fi
 417
 418                exit 1 ;;
 419
 420        esac
 421}
 422
 423if test -n "$valgrind"
 424then
 425        make_symlink () {
 426                test -h "$2" &&
 427                test "$1" = "$(readlink "$2")" || {
 428                        # be super paranoid
 429                        if mkdir "$2".lock
 430                        then
 431                                rm -f "$2" &&
 432                                ln -s "$1" "$2" &&
 433                                rm -r "$2".lock
 434                        else
 435                                while test -d "$2".lock
 436                                do
 437                                        say "Waiting for lock on $2."
 438                                        sleep 1
 439                                done
 440                        fi
 441                }
 442        }
 443
 444        make_valgrind_symlink () {
 445                # handle only executables, unless they are shell libraries that
 446                # need to be in the exec-path.  We will just use "#!" as a
 447                # guess for a shell-script, since we have no idea what the user
 448                # may have configured as the shell path.
 449                test -x "$1" ||
 450                test "#!" = "$(head -c 2 <"$1")" ||
 451                return;
 452
 453                base=$(basename "$1")
 454                symlink_target=$GIT_BUILD_DIR/$base
 455                # do not override scripts
 456                if test -x "$symlink_target" &&
 457                    test ! -d "$symlink_target" &&
 458                    test "#!" != "$(head -c 2 < "$symlink_target")"
 459                then
 460                        symlink_target=../valgrind.sh
 461                fi
 462                case "$base" in
 463                *.sh|*.perl)
 464                        symlink_target=../unprocessed-script
 465                esac
 466                # create the link, or replace it if it is out of date
 467                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 468        }
 469
 470        # override all git executables in TEST_DIRECTORY/..
 471        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 472        mkdir -p "$GIT_VALGRIND"/bin
 473        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 474        do
 475                make_valgrind_symlink $file
 476        done
 477        # special-case the mergetools loadables
 478        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 479        OLDIFS=$IFS
 480        IFS=:
 481        for path in $PATH
 482        do
 483                ls "$path"/git-* 2> /dev/null |
 484                while read file
 485                do
 486                        make_valgrind_symlink "$file"
 487                done
 488        done
 489        IFS=$OLDIFS
 490        PATH=$GIT_VALGRIND/bin:$PATH
 491        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 492        export GIT_VALGRIND
 493elif test -n "$GIT_TEST_INSTALLED"
 494then
 495        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 496        error "Cannot run git from $GIT_TEST_INSTALLED."
 497        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 498        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 499else # normal case, use ../bin-wrappers only unless $with_dashes:
 500        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 501        if ! test -x "$git_bin_dir/git"
 502        then
 503                if test -z "$with_dashes"
 504                then
 505                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 506                fi
 507                with_dashes=t
 508        fi
 509        PATH="$git_bin_dir:$PATH"
 510        GIT_EXEC_PATH=$GIT_BUILD_DIR
 511        if test -n "$with_dashes"
 512        then
 513                PATH="$GIT_BUILD_DIR:$PATH"
 514        fi
 515fi
 516GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 517unset GIT_CONFIG
 518GIT_CONFIG_NOSYSTEM=1
 519GIT_ATTR_NOSYSTEM=1
 520export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 521
 522if test -z "$GIT_TEST_CMP"
 523then
 524        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 525        then
 526                GIT_TEST_CMP="$DIFF -c"
 527        else
 528                GIT_TEST_CMP="$DIFF -u"
 529        fi
 530fi
 531
 532GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 533export GITPERLLIB
 534test -d "$GIT_BUILD_DIR"/templates/blt || {
 535        error "You haven't built things yet, have you?"
 536}
 537
 538if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 539then
 540        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 541        export GITPYTHONLIB
 542        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 543                error "You haven't built git_remote_helpers yet, have you?"
 544        }
 545fi
 546
 547if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 548then
 549        echo >&2 'You need to build test-chmtime:'
 550        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 551        exit 1
 552fi
 553
 554# Test repository
 555test="trash directory.$(basename "$0" .sh)"
 556test -n "$root" && test="$root/$test"
 557case "$test" in
 558/*) TRASH_DIRECTORY="$test" ;;
 559 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
 560esac
 561test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 562rm -fr "$test" || {
 563        GIT_EXIT_OK=t
 564        echo >&5 "FATAL: Cannot prepare test area"
 565        exit 1
 566}
 567
 568HOME="$TRASH_DIRECTORY"
 569export HOME
 570
 571if test -z "$TEST_NO_CREATE_REPO"
 572then
 573        test_create_repo "$test"
 574else
 575        mkdir -p "$test"
 576fi
 577# Use -P to resolve symlinks in our working directory so that the cwd
 578# in subprocesses like git equals our $PWD (for pathname comparisons).
 579cd -P "$test" || exit 1
 580
 581this_test=${0##*/}
 582this_test=${this_test%%-*}
 583for skp in $GIT_SKIP_TESTS
 584do
 585        case "$this_test" in
 586        $skp)
 587                say_color info >&3 "skipping test $this_test altogether"
 588                skip_all="skip all tests in $this_test"
 589                test_done
 590        esac
 591done
 592
 593# Provide an implementation of the 'yes' utility
 594yes () {
 595        if test $# = 0
 596        then
 597                y=y
 598        else
 599                y="$*"
 600        fi
 601
 602        while echo "$y"
 603        do
 604                :
 605        done
 606}
 607
 608# Fix some commands on Windows
 609case $(uname -s) in
 610*MINGW*)
 611        # Windows has its own (incompatible) sort and find
 612        sort () {
 613                /usr/bin/sort "$@"
 614        }
 615        find () {
 616                /usr/bin/find "$@"
 617        }
 618        sum () {
 619                md5sum "$@"
 620        }
 621        # git sees Windows-style pwd
 622        pwd () {
 623                builtin pwd -W
 624        }
 625        # no POSIX permissions
 626        # backslashes in pathspec are converted to '/'
 627        # exec does not inherit the PID
 628        test_set_prereq MINGW
 629        test_set_prereq SED_STRIPS_CR
 630        ;;
 631*CYGWIN*)
 632        test_set_prereq POSIXPERM
 633        test_set_prereq EXECKEEPSPID
 634        test_set_prereq NOT_MINGW
 635        test_set_prereq SED_STRIPS_CR
 636        ;;
 637*)
 638        test_set_prereq POSIXPERM
 639        test_set_prereq BSLASHPSPEC
 640        test_set_prereq EXECKEEPSPID
 641        test_set_prereq NOT_MINGW
 642        ;;
 643esac
 644
 645( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 646test -z "$NO_PERL" && test_set_prereq PERL
 647test -z "$NO_PYTHON" && test_set_prereq PYTHON
 648test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 649test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 650
 651# Can we rely on git's output in the C locale?
 652if test -n "$GETTEXT_POISON"
 653then
 654        GIT_GETTEXT_POISON=YesPlease
 655        export GIT_GETTEXT_POISON
 656        test_set_prereq GETTEXT_POISON
 657else
 658        test_set_prereq C_LOCALE_OUTPUT
 659fi
 660
 661# Use this instead of test_cmp to compare files that contain expected and
 662# actual output from git commands that can be translated.  When running
 663# under GETTEXT_POISON this pretends that the command produced expected
 664# results.
 665test_i18ncmp () {
 666        test -n "$GETTEXT_POISON" || test_cmp "$@"
 667}
 668
 669# Use this instead of "grep expected-string actual" to see if the
 670# output from a git command that can be translated either contains an
 671# expected string, or does not contain an unwanted one.  When running
 672# under GETTEXT_POISON this pretends that the command produced expected
 673# results.
 674test_i18ngrep () {
 675        if test -n "$GETTEXT_POISON"
 676        then
 677            : # pretend success
 678        elif test "x!" = "x$1"
 679        then
 680                shift
 681                ! grep "$@"
 682        else
 683                grep "$@"
 684        fi
 685}
 686
 687test_lazy_prereq SYMLINKS '
 688        # test whether the filesystem supports symbolic links
 689        ln -s x y && test -h y
 690'
 691
 692test_lazy_prereq CASE_INSENSITIVE_FS '
 693        echo good >CamelCase &&
 694        echo bad >camelcase &&
 695        test "$(cat CamelCase)" != good
 696'
 697
 698test_lazy_prereq UTF8_NFD_TO_NFC '
 699        # check whether FS converts nfd unicode to nfc
 700        auml=$(printf "\303\244")
 701        aumlcdiar=$(printf "\141\314\210")
 702        >"$auml" &&
 703        case "$(echo *)" in
 704        "$aumlcdiar")
 705                true ;;
 706        *)
 707                false ;;
 708        esac
 709'
 710
 711# When the tests are run as root, permission tests will report that
 712# things are writable when they shouldn't be.
 713test -w / || test_set_prereq SANITY